/*
 * Copyright (C) 1996 Piero Orsoni
 */


#include <stdlib.h>
#include <stdio.h>
#include "pt.h"
#include "ptrc.h"


void Write_Default_Ptrc() {
    FILE *f;
    char line[256];
    char s[512];
    short i = 0;
    strcpy (s, getenv ("HOME"));
    strcat (s, RCNAME);
    if ((f = fopen (s, "w")) == NULL) {
	fprintf (stderr, "pt: cannot open %s for writing\n", s);
	return;
    }
    while (default_ptrc[i] != 0)
	fwrite (&default_ptrc[i++], 1, 1, f);
    fclose (f);
}


void Tmp_Buffer_To_Buffer() {
    long i;
    buffer_size = tmp_buffer_size;
    buffer = realloc (buffer, buffer_size);
    for (i = 0; i < tmp_buffer_size; i++)
	buffer[i] = tmp_buffer[i];
    free (tmp_buffer);
}


char Is_Binary() {
    long i;
    for (i = 0; i < buffer_size; i++)
	if (buffer[i] < 0)
	    return 1;
    return 0;
}


void Low_Case() {
    long i;
    for (i = 0; i < buffer_size; i++)
	buffer[i] = tolower (buffer[i]);
}


void Up_Case() {
    long i;
    for (i = 0; i < buffer_size; i++)
	buffer[i] = toupper (buffer[i]);
}


void Switch_Case() {
    long i;
    for (i = 0; i < buffer_size; i++)
	if ((buffer[i] >= 'a') && (buffer[i] <= 'z'))
	    buffer[i] = toupper (buffer[i]);
	else if ((buffer[i] >= 'A') && (buffer[i] <= 'Z'))
	    buffer[i] = tolower (buffer[i]);
}


void Word_Case() {
    long i;
    for (i = 0; i < buffer_size; i++)
	if ((i == 0) || (buffer[i-1] == ' ') || (buffer[i-1] == 9)
	   || (buffer[i-1] == '\n') || (buffer[i-1] == '\r')
	   || (buffer[i-1] == '(')  || (buffer[i-1] == '\"')
	   || (buffer[i-1] == '\'') || (buffer[i-1] == '['))
	    buffer[i] = toupper (buffer[i]);
}


void Period_Case() {
    long i;
    char period_start = 1;
    for (i = 0; i < buffer_size; i++) {
	if ((period_start) && (buffer[i] != ' ') && (buffer[i] != 9)
	   && (buffer[i] != '\n') && (buffer[i] != '\r')
	   && (buffer[i] != '(')  && (buffer[i] != '\"')
	   && (buffer[i] != '\'') && (buffer[i] != '[')) {
	    buffer[i] = toupper (buffer[i]);
	    period_start = 0;
	}
	if (((buffer[i] == '.') && (i < buffer_size - 1) && (
	      (buffer[i+1] == ' ')  || (buffer[i+1] == 9)
	   || (buffer[i+1] == '\n') || (buffer[i+1] == '\r')
	   || (buffer[i+1] == '(')  || (buffer[i+1] == '\"')
	   || (buffer[i+1] == '\'') || (buffer[i+1] == '['))
	   || (buffer[i+1] == '\n') || (buffer[i+1] == '\r')))
	    period_start = 1;
    }
}


void Paragraph_Case() {
    long i;
    char paragraph_start = 1;
    for (i = 0; i < buffer_size; i++) {
	if ((paragraph_start) && (buffer[i] != ' ') && (buffer[i] != 9)
	   && (buffer[i] != '\n') && (buffer[i] != '\r')
	   && (buffer[i] != '(')  && (buffer[i] != '\"')
	   && (buffer[i] != '\'') && (buffer[i] != '[')) {
	    buffer[i] = toupper (buffer[i]);
	    paragraph_start = 0;
	}
	if ((buffer[i+1] == '\n') || (buffer[i+1] == '\r'))
	    paragraph_start = 1;
    }
}


void To_Uneex() {
    long i, j = 0;
    for (i = 0; i < buffer_size; i++)
	if (((buffer[i] == '\n' && buffer[i+1] == '\r') ||
	    (buffer[i] == '\r' && buffer[i+1] == '\n')) &&
	    (i < buffer_size - 1)) {
	    buffer[j++] = '\n';
	    i++;
	}
	else if (buffer[i] != '\r')
	    buffer[j++] = buffer[i];
	else
	    buffer[j++] = '\n';
    buffer_size = j;
    buffer = realloc (buffer, buffer_size);
}


void To_Dos() {
    long i, j = 0;
    tmp_buffer = malloc (buffer_size * 2);
    for (i = 0; i < buffer_size; i++)
	if ((buffer[i] == '\n' && buffer[i+1] != '\r') ||
	    (buffer[i] == '\r' && buffer[i+1] != '\n')) {
	    tmp_buffer[j++] = '\r';
	    tmp_buffer[j++] = '\n';
	}
	else if ((buffer[i] != '\r') && (buffer[i] != '\n'))
	    tmp_buffer[j++] = buffer[i];
	else if (i < buffer_size - 1) {
	    tmp_buffer[j++] = buffer[i++];
	    tmp_buffer[j++] = buffer[i];
	}
    tmp_buffer_size = j;
    tmp_buffer = realloc (tmp_buffer, tmp_buffer_size);
    Tmp_Buffer_To_Buffer();
}


void To_Mac() {
    long i, j = 0;
    for (i = 0; i < buffer_size; i++)
	if (((buffer[i] == '\n' && buffer[i+1] == '\r') ||
	    (buffer[i] == '\r' && buffer[i+1] == '\n')) &&
	    (i < buffer_size - 1)) {
	    buffer[j++] = '\r';
	    i++;
	}
	else if (buffer[i] != '\r')
	    buffer[j++] = buffer[i];
	else
	    buffer[j++] = '\r';
    buffer_size = j;
    buffer = realloc (buffer, buffer_size);
}


void Remove_Enter() {
    long i, j = 0, jsav;
    for (i = 0; i < buffer_size; i++) {
	jsav = j;
	if (i > 0) {
	    if (i < buffer_size - 2)
		if (((buffer[i-1] != '\r') && (buffer[i-1] != '\n') &&
		    (buffer[i-1] != '.')) &&
		    ((buffer[i+2] != '\r') && (buffer[i+2] != '\n')))
		    if (((buffer[i] == '\r') && (buffer[i+1] == '\n')) ||
			((buffer[i] == '\n') && (buffer[i+1] == '\r'))) {
			buffer[j++] = ' ';
			i += 2;
			for (; (buffer[i] == ' ') || (buffer[i] == 9); i++);
			i--;
		    }
	    if ((i < buffer_size - 1) && (jsav == j))
		if (((buffer[i-1] != '\r') && (buffer[i-1] != '\n') &&
		    (buffer[i-1] != '.')) &&
		    ((buffer[i+1] != '\r') && (buffer[i+1] != '\n')))
		    if ((buffer[i] == '\r') || (buffer[i] == '\n')) {
			buffer[j++] = ' ';
			i++;
			for (; (buffer[i] == ' ') || (buffer[i] == 9); i++);
			i--;
		    }
	}
	if (jsav == j)
	    buffer[j++] = buffer[i];
    }
    buffer_size = j;
    buffer = realloc (buffer, buffer_size);
}


void Tab_To_Space() {
    long i, j = 0, jsav, l = tab_size;
    tmp_buffer_size = buffer_size;
    tmp_buffer = malloc (buffer_size * tab_size);
    for (i = 0; i < buffer_size; i++) {
	if (buffer[i] == 9) {
	    jsav = j;
	    if (l % tab_size == 0)
		jsav += tab_size;
	    else
		jsav += l % tab_size;
	    for (;j < jsav; j++, l--)
		tmp_buffer[j] = ' ';
	}
	else {
	    tmp_buffer[j++] = buffer[i];
	    l--;
	}
	if ((buffer [i] == '\n') || (buffer[i] == '\r') || (l == 0))
	    l = tab_size;
    }
    tmp_buffer_size = j;
    tmp_buffer = realloc (tmp_buffer, tmp_buffer_size);
    Tmp_Buffer_To_Buffer();
}


long Count_Spaces (char *s, long size) {
    long i;
    for (i = 0; (s[i] == ' ') && (i < size); i++);
    return i;
}


void Space_To_Tab() {
    long i, j = 0, l = 0;
    for (i = 0; i < buffer_size; i++) {
	if ((l != tab_size - 1) &&
	   (Count_Spaces (&buffer[i], buffer_size - i) + l >= tab_size)) {
	    buffer[j++] = 9;
	    i += tab_size - l - 1;
	    l = 0;
	}
	else {
	    buffer[j++] = buffer[i];
	    l++;
	    if ((buffer [i] == '\n') || (buffer[i] == '\r')
		|| (buffer[i] == 9) || (l == tab_size))
		l = 0;
	}
    }
    buffer_size = j;
    buffer = realloc (buffer, buffer_size);
}


void Get_Line (char *line, long begin) {
    long i;
    for (i = begin; (buffer[i] != '\n') && (buffer[i] != '\r') && (i < buffer_size); i++);
    if (i < buffer_size)
	if (((buffer[i] == '\n') && (buffer[i+1] == '\r')) ||
	    ((buffer[i] == '\r') && (buffer[i+1] == '\n')))
	    i++;
    strncpy (line, &buffer[begin], i - begin + 1);
    line[i - begin + 1] = 0;
}


void Insert_Line (char *line, long pos, long size) {
    long i, saved_size = tmp_buffer_size;
    tmp_buffer_size += size + pos;
    tmp_buffer = realloc (tmp_buffer, tmp_buffer_size);
    for (i = 0; i < pos; i++)
	tmp_buffer[i + saved_size] = ' ';
    for (i = 0; i < size; i++)
	tmp_buffer[i + saved_size + pos] = line[i];
}


char Is_Right_Indent (char *s) {
    char i;
    for (i = 0; i < right_indent_num; i++)
	if (!strncmp(s, right_indent[i], strlen (right_indent[i])))
	    return 1;
    return 0;
}


char Is_Left_Indent (char *s) {
    char i;
    for (i = 0; i < left_indent_num; i++)
	if (!strncmp(s, left_indent[i], strlen (left_indent[i])))
	    return 1;
    return 0;
}


/*char Is_Line_Indent (char *s) {
    char i;
    for (i = 0; i < line_indent_num; i++)
	if (!strncmp(s, line_indent[i], strlen (line_indent[i])))
	    return 1;
    return 0;
}*/


/*char Is_Pause_Indent (char *s) {
    char i;
    for (i = 0; i < pause_indent_num; i++)
	if (!strncmp(s, pause_indent[i], strlen (pause_indent[i])))
	    if (s[0] !=) return 1;
    return 0;
}*/


long New_Pos (char *line, long pos, long size) {
    long i;
    for (i = 0; i < size; i++)
	if (Is_Right_Indent (&line[i]))
	    pos += indent_size;
	else if (Is_Left_Indent (&line[i]))
	    if (pos > 0)
		pos -= indent_size;
	    else {
		fprintf (stderr, "pt: error indenting at line: %s\n",line);
		exit (1);
	    }
	/*else if (Is_Line_Indent (&line[i]))
	    pos = -1 - indent_size;*/
    return pos;
}


void Indent() {
    long i, pos = 0, psav;
    char *line, *line2;
    if ((right_indent_num == 0) || (left_indent_num == 0)) {
	fprintf (stderr, "pt: must specifie at least one right_indent and one left_indent in .ptrc\n");
	exit (1);
    }
    line = malloc (buffer_size);
    tmp_buffer_size = 0;
    tmp_buffer = NULL;
    for (i = 0; i < buffer_size;) {
	Get_Line (line, i);
	i += strlen (line);
	line2 = Strip_Leading_Spaces (line);
	psav = pos;
	pos = New_Pos (line2, pos, strlen (line2));
	if (pos > psav) {
	    pos -= indent_size;
	    psav = -1;
	}
	if ((pos < psav) && (!Is_Left_Indent (line2))) {
	    pos += indent_size;
	    psav = -2;
	}
	Insert_Line (line2, pos, strlen (line2));
	if (psav == -1)
	    pos += indent_size;
	if (psav == -2)
	    pos -= indent_size;
    }
    free (line);
    Tmp_Buffer_To_Buffer();
}


void Encrypt() {
    long i;
    if (strlen (password) < 1) {
	fprintf (stderr, "pt: you need a password in .ptrc if you'd like to encrypt or uncrypt\n");
	exit (1);
    }
    for (i = 0; i < buffer_size; i++)
	buffer[i] = buffer [i] ^ (password[i % strlen (password)] + 7);
}


void Strip_Binary() {
    long i;
    tmp_buffer = malloc (buffer_size);
    tmp_buffer_size = 0;
    for (i = 0; i < buffer_size; i++)
	if (buffer[i] > -1)
	    tmp_buffer[tmp_buffer_size++] = buffer[i];
    Tmp_Buffer_To_Buffer();
}


void Strip_8th_Bit() {
    long i;
    for (i = 0; i < buffer_size; i++)
	buffer[i] = buffer[i] & 127;
}


void Delete_Line_Ends() {
    long i, last = 0;
    tmp_buffer = malloc (buffer_size);
    tmp_buffer_size = 0;
    for (i = 0; i < buffer_size; i++) {
	if (((buffer[i] == '\n') || (buffer[i] == '\r')) && (last < i))
	    tmp_buffer_size -= i - last - 1;
	tmp_buffer[tmp_buffer_size++] = buffer[i];
	if ((buffer[i] != ' ') && (buffer[i] != 9))
	    last = i;
    }
    Tmp_Buffer_To_Buffer();
}
