/*
 * Copyright (C) 1996 Piero Orsoni
 */


#include <stdio.h>
#include <stdlib.h>
#include "pt.h"


long File_Size (FILE *f) {
    long temp;
    fseek (f, 0, SEEK_END);
    temp = ftell (f);
    fseek (f, 0, SEEK_SET);
    return temp;
}


void Make_Backup (char *name) {
    char *s;
    s = malloc (strlen (name) * 2 + 9);
    strcpy (s, COPY);
    strcat (s, name);
    strcat (s, " ");
    strcat (s, name);
    strcat (s, "~");
    if (system (s))
	fprintf (stderr, "pt: can't make backup for %s\n", name);
    free (s);
}


void Load_File (char *name) {
    FILE *f;
    if ((f = fopen (name, "r")) == NULL) {
	fprintf (stderr, "pt: can't open input file %s\n", name);
	exit (1);
    }
    buffer_size = File_Size (f);
    buffer = malloc (buffer_size);
    fread (buffer, 1, buffer_size ,f);
    fclose (f);
}


void Save_File (char *name) {
    FILE *f;
    if ((f = fopen (name, "w")) == NULL) {
	fprintf (stderr, "pt: can't open output file %s\n", name);
	exit (1);
    }
    fwrite (buffer, 1, buffer_size ,f);
    fclose (f);
    free (buffer);
}


void Load_Stdin() {
    char c;
    buffer_size = 0;
    buffer = NULL;
    while (!feof (stdin)) {
	c = getchar();
	if (c == EOF) break;
	buffer = realloc (buffer, ++buffer_size);
	buffer[buffer_size - 1] = c;
    }
}


void Save_Stdin() {
    fwrite (buffer, 1, buffer_size, stdout);
    free (buffer);
}


void Compute_Memorized_File() {
    if (strip_binary == 1)
	Strip_Binary();
    if (strip_binary == 2)
	Strip_8th_Bit();
    if (do_crypt == 2)
	Encrypt();
    switch (what_case) {
	case 1: Low_Case();	  break;
	case 2: Up_Case();	  break;
	case 3: Word_Case();	  break;
	case 4: Period_Case();	  break;
	case 5: Paragraph_Case(); break;
    }
    if (switch_case)
	Switch_Case();
    switch (convert_to) {
	case 1: To_Uneex(); break;
	case 2: To_Dos();  break;
	case 3: To_Mac();  break;
    }
    if (remove_enter)
	Remove_Enter();
    if (delete_line_ends)
	Delete_Line_Ends();
    if (indent)
	Indent();
    if (tab_to_space == 1)
	Tab_To_Space();
    if (tab_to_space == 2)
	Space_To_Tab();
    if (do_crypt == 1)
	Encrypt();
}


void Do_Files() {
    short i;
    if (write_default_ptrc == 1) {
	Write_Default_Ptrc();
	printf ("pt: default .ptrc created\n");
	exit (0);
    }
    if (num_files == 0) {
	Load_Stdin();
	Compute_Memorized_File();
	Save_Stdin();
    }
    for (i = 0; i < num_files; i++) {
	if (verbose)
	    printf ("%s\n", files[i]);
	Load_File (files[i]);
	if (Is_Binary())
	    fprintf (stderr, "pt: warning, the file: %s can be binary\n", files[i]);
	Compute_Memorized_File();
	if (make_backups)
	    Make_Backup (files[i]);
	Save_File (files[i]);
	free (files[i]);
    }
}
