/*
 * Copyright (C) 1996 Piero Orsoni
 */


#include <stdlib.h>
#include <stdio.h>
#include "pt.h"


void Print_Version() {
    printf ("Pluto Text utility 0.6 27/OCT/96 - Copyright (C) 1996 Piero Orsoni\n");
}


void Usage() {
    printf ("usage: pt [-{([{LUWPA}][S][{udm}][e][{ts}][i][{cy}][l][b])r}[v][V]] [file]...\n\n");
    printf ("-L	Convert any character to lowercase\n");
    printf ("-U	Convert any character to uppercase\n");
    printf ("-W	Convert first letter of any word to uppercase\n");
    printf ("-P	Convert first letter of any period to uppercase\n");
    printf ("-A	Convert first letter of any paragraph to uppercase\n");
    printf ("-S	Switch uppercase to lowercase and vice versa\n");
    printf ("-u	Convert to UN*X text file format\n");
    printf ("-d	Convert to DOS	text file format\n");
    printf ("-m	Convert to MAC	text file format\n");
    printf ("-e	Remove Enters that are not at the end of a paragraph\n");
    printf ("-t	Convert Tabs to Spaces\n");
    printf ("-s	Convert Spaces to Tabs\n");
    printf ("-i	Perform indentation\n");
    printf ("-c	Encrypt output - WARNING! SEE MANPAGES IF YOU PLAN TO USE IT!\n");
    printf ("-y	Uncrypt input\n");
    printf ("-B	Strip binary part of the file\n");
    printf ("-8	Strip 8th bit\n");
    printf ("-l	Delete spaces and tabs at the end of each line\n");
    printf ("-r	Create default configuration file ~/.ptrc\n");
    printf ("-b	Don't make backup copies of processed files\n");
    printf ("-v	Verbose mode\n");
    printf ("-V	Print version information\n");
    exit (0);
}


void Compute_Options (char *options) {
    short i;
    for (i = 0; i<strlen (options); i++) {
	switch (options[i]) {
	    case ' ':break;   /* for semplifying default options process */
	    case 'L':
		if (what_case == 0)
		    what_case = 1;
		else {
		    fprintf (stderr, "pt: please specifie only one case type\n");
		    exit (1);
		} break;
	    case 'U':
		if (what_case == 0)
		    what_case = 2;
		else {
		    fprintf (stderr, "pt: please specifie only one case type\n");
		    exit (1);
		} break;
	    case 'S':
		switch_case = 1; break;
	    case 'W':
		if (what_case == 0)
		    what_case = 3;
		else {
		    fprintf (stderr, "pt: please specifie only one case type\n");
		    exit (1);
		} break;
	    case 'P':
		if (what_case == 0)
		    what_case = 4;
		else {
		    fprintf (stderr, "pt: please specifie only one case type\n");
		    exit (1);
		} break;
	    case 'A':
		if (what_case == 0)
		    what_case = 5;
		else {
		    fprintf (stderr, "pt: please specifie only one case type\n");
		    exit (1);
		} break;
	    case 'u':
		if (convert_to == 0)
		    convert_to = 1;
		else {
		    fprintf (stderr, "pt: please specifie only one system to convert to\n");
		    exit (1);
		} break;
	    case 'd':
		if (convert_to == 0)
		    convert_to = 2;
		else {
		    fprintf (stderr, "pt: please specifie only one system to convert to\n");
		    exit (1);
		} break;
	    case 'm':
		if (convert_to == 0)
		    convert_to = 3;
		else {
		    fprintf (stderr, "pt: please specifie only one system to convert to\n");
		    exit (1);
		} break;
	    case 'e':
		remove_enter = 1; break;
	    case 't':
		if (tab_to_space == 0)
		    tab_to_space = 1;
		else {
		    fprintf (stderr, "pt: please specifie tab to space or space to tab\n");
		} break;
	    case 's':
		if (tab_to_space == 0)
		    tab_to_space = 2;
		else {
		    fprintf (stderr, "pt: please specifie tab to space or space to tab\n");
		} break;
	    case 'i':
		indent = 1; break;
	    case 'c':
		if (do_crypt == 0)
		    do_crypt = 1;
		else {
		    fprintf (stderr, "pt: please specifie encrypt or uncrypt\n");
		} break;
	    case 'y':
		if (do_crypt == 0)
		    do_crypt = 2;
		else {
		    fprintf (stderr, "pt: please specifie encrypt or uncrypt\n");
		} break;
	    case 'B':
		strip_binary = 1; break;
	    case '8':
		strip_binary = 2; break;
	    case 'l':
		delete_line_ends = 1; break;
	    case 'r':
		write_default_ptrc = 1; break;
	    case 'b':
		make_backups = 0; break;
	    case 'v':
		verbose = 1; break;
	    case 'V':
		Print_Version(); break;
	    default:
		fprintf (stderr, "pt: unrecognised option: %c\n", options[i]);
	}
    }
}


void Add_File_Name (char *name) {
    if (num_files == 3001) {
	fprintf (stderr, "pt: too many files to process (max 3000)\n");
	exit (1);
    }
    files[num_files] = malloc (strlen (name) + 1);
    strcpy (files[num_files], name);
    num_files++;
}


void Compute_Args (short argc, char *argv[]) {
    short i;

    /* printf("\nWARNING - THIS IS A TEST VERSION - PLEASE DON'T DISTRIBUTE\n");
    printf("YOU CAN FIND A STABLE VERSION AT: maya.dei.unipd.it/pub/pluto/progs\n\n");
    */

    if (argc == 1)
       Usage();
    for (i = 1; i<argc; i++)
	if (argv[i][0] == '-')
	    Compute_Options (&argv[i][1]);
	else
	    Add_File_Name (&argv[i][0]);
    if ((!what_case) && (!switch_case) && (!convert_to) && (!remove_enter) &&
	(!tab_to_space) && (!indent) && (!write_default_ptrc) && (!do_crypt) &&
	(!strip_binary) && (!delete_line_ends)) {
	fprintf (stderr, "pt: nothing to do\n");
	exit (1);
    }
}
